<template>
  <div class="header">
      <template>
        <div>
          <v-menu offset-y transition="slide-y-transition">
            <template v-slot:activator="{ on }">
                <v-btn text v-on="on">
                  <v-icon class="mr-1">mdi-account-outline</v-icon> {{name}}
                </v-btn>
            </template>
            <v-card>
             <v-list> 
                 <v-list-item-group>           
                  <v-list-item>
                    <v-list-item-title style="width:250px">
                        <span class="th-s">Username</span><br>
                        <span class="tl-m">{{ name }}</span>
                    </v-list-item-title>
                  </v-list-item>
                  <v-list-item>
                    <v-list-item-title>
                        <span class="th-s">Last Login</span><br>
                        <span class="tl-m">{{ new Date(last_login).toLocaleString("es-CL") }}</span>
                    </v-list-item-title>
                  </v-list-item>
                  <v-divider></v-divider>
                  <v-list-item v-on:click="logout()">
                    <v-list-item-title><v-icon class="mr-1">mdi-lock-outline</v-icon> Logout</v-list-item-title>
                  </v-list-item>
                </v-list-item-group>
              </v-list>
            </v-card>
          </v-menu>
        </div>
      </template>
    </div>
</template>

<script>
export default {
  props: { value: { type: Object } },
  computed: {
    show: {
      get() {
        let self = this;
        if (self.value["data"]) {
          self.data = self.value.data;
        }
        return self.value["val"];
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    loginCheck() {
      var token = localStorage.getItem("token");
      var name = localStorage.getItem("name");
      var last_login = localStorage.getItem("last_login");
      var username = localStorage.getItem("username");

      if (!token || !name || !last_login || !username) {
        this.$router.push("/login");
      }
    },
    logout() {
      this.$dialog.confirm({
        text: "Are you sure you want to log out ?",
        overlay: true,
        actions: {
          false: "Cancel",
          true: {
            color: "green",
            text: "Logout",
            handle: () => {
              localStorage.setItem("token", "");
              localStorage.setItem("name", ""); 
              localStorage.setItem("last_login", "");
              localStorage.setItem("username", "");
              localStorage.setItem("password", "");
              this.$router.push("/login");
            },
          },
        },
      });
    },
    async getToken() {
      let self = this;
      let url = self.base_url + "api/v1/login";
      let apiRes = null; 

      try {
        let data = {
          username: self.username,
          password: self.password,
        };

        apiRes = await self.axios.post(url, data, {
          headers: {
            "Content-Type": "application/json;charset=UTF-8",
          },
        });
      } catch (err) {
        alert(err.response.data['message']);
        this.logout();
      } finally {
        localStorage.setItem("token",apiRes.data["token"]);
      }
    }
  },
  mounted() {
    if(this.token){
      this.getToken();
    }
  },
  data: function() {
    return {
      data: "",
      name: localStorage.getItem("name"),
      last_login: localStorage.getItem("last_login"),
      username:  localStorage.getItem("username"),
      password:  localStorage.getItem("password"),
      token: localStorage.getItem("token")
    };
  },
};
</script>
